using GTA;
using GTA.Native;
using System;
using System.Diagnostics;
using System.Drawing;
using System.Reflection;
using System.Runtime.CompilerServices;
using System.Runtime.InteropServices;
using System.Runtime.Versioning;
using System.Windows.Forms;

namespace Bar
{
	public class cs : Script
	{
		private Keys toggleMenuKey;
		private Keys selectionKey;
		private Keys menuUpKey;
		private Keys menuDownKey;
		private bool isMenuOn;
		private bool menuReady;
		private int menuSelection;
		private float x;
		private float y;
		private float spacing;
		private Vector3[] positions;
		private bool Bar()
		{
			Vector3[] array = this.positions;
			for (int i = 0; i < array.Length; i++)
			{
				Vector3 position = array[i];
				if (base.Player.Character.Position.DistanceTo(position) < 2f)
				{
					return true;
				}
			}
			return false;
		}
		
		public cs()
		{
			this.positions = new Vector3[]
			{
			// Ajoutez une ligne Vector3 ci-dessous avec les coordonnées de votre bar . N'oubliez pas les f et l'absence de virgule à la dernière ligne
				//Ile est
				new Vector3(926.94f, -489.96f, 15.34f),
				new Vector3(1431.48f, 19.73f, 25.95f),
				new Vector3(1468.16f, 58.09f, 25.19f),
				new Vector3(1145.97f, 739.11f, 35.52f),
				// Ile centrale
				new Vector3(-441.97f, 456.71f, 9.84f),
				new Vector3(-31.73f, -207.11f, 14.77f),
				new Vector3(79.20f, 557.54f, 18.63f),
				new Vector3(99.34f, 845.51f, 45.05f),
				new Vector3(111.65f, -5.12f, 14.83f),
				new Vector3(-629.11f, -40.02f, 4.82f),
				// Ile ouest
				new Vector3(-1507.84f, 539.95f, 19.57f),
				new Vector3(-1507.44f, 532.08f, 19.57f),
				new Vector3(-1574.87f, 15.54f, 10.02f),
				new Vector3(-1565.29f, 15.24f, 10.02f),
				new Vector3(-1560.99f, 6.07f, 10.02f),
				new Vector3(-1570.81f, 6.08f, 10.02f)
			};
			// Enlever les // ci-dessous (uniquement ci-dessous) pour avoir les emplacements des bars sur la carte
			//Vector3[] array = this.positions;
			//for (int i = 0; i < array.Length; i++)
			//{
				//Vector3 target = array[i];
				//Blip blip = Blip.AddBlip(target);
				//blip.Name = "YOU WILL NEVER SEE THIS";
				//blip.ShowOnlyWhenNear = true;
				//blip.Icon = BlipIcon.Activity_Bar;
				//blip.Scale = 1f;
				//blip.Display = BlipDisplay.ArrowAndMap;
			//}
			this.x = (float)Game.Resolution.Width * 0.1f;
			this.y = (float)Game.Resolution.Height * 0.1f;
			this.spacing = (float)Game.Resolution.Height / 50f;
			// ci-dessous vous pouvez modifier la touche d'appel du menu . Remplacez Keys.U par Keys.Touche
			this.toggleMenuKey = base.Settings.GetValueKey("TOGGLE_MENU_KEY", Keys.U);
			this.selectionKey = base.Settings.GetValueKey("SELECTION_KEY", Keys.Return);
			this.menuUpKey = base.Settings.GetValueKey("MENU_UP_KEY", Keys.Up);
			this.menuDownKey = base.Settings.GetValueKey("MENU_DOWN_KEY", Keys.Down);
			base.BindKey(this.toggleMenuKey, false, false, false, new KeyPressDelegate(this.ToggleMenu));
			base.Tick += new EventHandler(this.HelpTick);
		}
		
		private void ToggleMenu()		
		{	
			if (!this.menuReady)
			{
				return;
			}
			this.isMenuOn = !this.isMenuOn;
			if (this.isMenuOn)
			{
				base.Tick -= new EventHandler(this.HelpTick);
				base.PerFrameDrawing += new GraphicsEventHandler(this.Menu_PerFrameDrawing);
				base.KeyDown += new GTA.KeyEventHandler(this.Menu_KeyDown);
				base.Player.CanControlCharacter = false;
				return;
			}
			base.Tick += new EventHandler(this.HelpTick);
			base.PerFrameDrawing -= new GraphicsEventHandler(this.Menu_PerFrameDrawing);
			base.KeyDown -= new GTA.KeyEventHandler(this.Menu_KeyDown);
			base.Player.CanControlCharacter = true;
		}
		
		private void Menu_KeyDown(object sender, GTA.KeyEventArgs e)
		{
			if (e.Key == this.menuUpKey)
			{
				this.menuSelection--;
				this.menuSelection = ((this.menuSelection < 0) ? 2 : this.menuSelection);
			}
			if (e.Key == this.menuDownKey)
			{
				this.menuSelection++;
				this.menuSelection = ((this.menuSelection > 2) ? 0 : this.menuSelection);
			}
			if (e.Key == this.selectionKey)
			{
				switch (this.menuSelection)
				{
				case 0:
					this.VingtMin();
					return;
				case 1:
					this.UneHeure();
					return;
				case 2:
					this.DeuxHeures();
					//return;
				//case 3:
					//this.DeuxHeuresD();
					break;
				default:
					return;
				}
			}
		}
		
		private void Menu_PerFrameDrawing(object sender, GraphicsEventArgs e)
		{
			e.Graphics.DrawText("Faire une pause de 20 minutes (15$)", this.x, this.y, (this.menuSelection == 0) ? Color.Silver : Color.White);
			e.Graphics.DrawText("Faire une pause de 1 heure (15$)", this.x, this.y + this.spacing, (this.menuSelection == 1) ? Color.Silver : Color.White);
			e.Graphics.DrawText("Faire une pause de 2 heures (15$)", this.x, this.y + this.spacing * 2f, (this.menuSelection == 2) ? Color.Silver : Color.White);
			//e.Graphics.DrawText("Faire une pause de 2 heures (20$)", this.x, this.y + this.spacing * 3f, (this.menuSelection == 3) ? Color.Silver : Color.White);
		}
		
		private void VingtMin()
		{
			if (base.Player.Money >= 15)
			{
				Game.FadeScreenOut(2000, true);
				Function.Call("SET_TIME_OF_DAY", new Parameter[]
				{
					World.CurrentDayTime.Hours ,
					World.CurrentDayTime.Minutes + 20
				});
				Wait(0);
				this.ToggleMenu();
				Game.FadeScreenIn(2000, true);
				base.Player.Money -= 15;
				return;
			}
			Game.DisplayText("Pas assez d'argent.");
		}
		
		private void UneHeure()
		{
			if (base.Player.Money >= 15)
			{
				Game.FadeScreenOut(2000, true);
				Function.Call("SET_TIME_OF_DAY", new Parameter[]
				{
					World.CurrentDayTime.Hours + 1,
					World.CurrentDayTime.Minutes 
				});
				Wait(0);
				this.ToggleMenu();
				Game.FadeScreenIn(2000, true);
				base.Player.Money -= 15;
				return;
			}
			Game.DisplayText("Pas assez d'argent.");
		}
		
		private void DeuxHeures()
		{
			if (base.Player.Money >= 15)
			{
				Game.FadeScreenOut(2000, true);
				Function.Call("SET_TIME_OF_DAY", new Parameter[]
				{
					World.CurrentDayTime.Hours + 2,
					World.CurrentDayTime.Minutes
				});
				Wait(0);
				this.ToggleMenu();
				Game.FadeScreenIn(2000, true);
				base.Player.Money -= 15;
				return;
			}
			Game.DisplayText("Pas assez d'argent.");
		}
			
		private void HelpTick(object sender, EventArgs e)
		{
			this.menuReady = this.Bar();
			if (this.menuReady)
			{
				Game.DisplayText("Appuie sur U pour faire une pause");
			}
		}
	}
}